// SlucajniT.java - Testiranje generatora slucajnih brojeva

import slucajni.*;
import java.awt.*;
import java.awt.event.*;

public class SlucajniT extends Frame {
  
  private Generator generator;
  private Posmatrac posmatrac;
  private Statistika[] stat;
  private PloGenerator ploGen;
  private TextField[] tekst;
  private TextArea tksRasp;
  private CheckboxGroup grupa;
  private boolean novaRasp = true;
  private String[] oznRasp = { "uniformna", "ekspon", "normalna" };
  
  // Konstruktor prozora aplikacije.
  private SlucajniT () {
    super ("Slucani brojevi");
    setBounds (100, 100, 500, 400);
    addWindowListener (new ProzorDogadjaj());
    setLayout (new BorderLayout());
    setBackground (new Color (208, 208, 208));
    setResizable (false);
    
    // Ploca za rukovajne aplikacijom.
    Panel ploIzbor = new Panel();
    ploIzbor.setLayout (new GridLayout(2,1));
    add (ploIzbor, "South");
    ploGen = new PloGenerator();
    ploIzbor.add (ploGen);
    ploIzbor.add (new PloRaspodela());
    
    // Ploce za prikazivanje statistickih pokazatelja.
    Panel plo = new Panel (); add (plo, "Center");
    plo.setLayout (new GridLayout(2,1));
    Panel plo1 = new Panel (); plo.add (plo1);
    Panel plo2 = new Panel (); plo.add (plo2);

    String[] ozn = {"      n", " min", "max",
                    "    sr", " dev", null};
    int br = ozn.length;
    posmatrac = new Prikazi ();
    tekst = new TextField [br];
    stat = new Statistika [br];
    stat[0] = new Brojac ();
    stat[1] = new Min ();
    stat[2] = new Max ();
    stat[3] = new Srednja ();
    stat[4] = new Devijacija ();
    stat[5] = new Raspodela (0, 1, 18, 280);

    plo1.setLayout (new GridLayout (br-1,1));
    plo2.setLayout (new GridLayout (1,1));
    generator = new Generator ();
    for (int i=0; i<br; i++) {
      if (i != 5) {
        plo1.add (new PloStatist (ozn[i], stat[i],
                  tekst[i]=new TextField(20)));
      } else {
        plo2.add (new PloStatist (ozn[i], stat[i],
                  tksRasp=new TextArea (20, 100) ));
                  tksRasp.setFont (new Font (null, Font.BOLD, 5));
      }
      stat[i].dodaj (posmatrac);
      generator.dodaj (stat[i]);
    }

  } // SlucajniT()

  // Glavni program aplikacije.
  public static void main (String[] vpar) {
    new SlucajniT ().show ();
  }
  
  // Posmatrac dogadjaja prozora.
  private class ProzorDogadjaj extends WindowAdapter {
    public void windowClosing (WindowEvent d) {
      System.exit (0);
    }
  } // class SlucajniT.ProzorDogadjaj
 
  // Prikazivanje sadrzaja statistickih pokazatelja.
  private class Prikazi implements Posmatrac {
    public void azuriraj(Subjekat subj) {
      for (int i=0; i<stat.length; i++)
        if (subj == stat[i])
          if (i!=5) tekst[i].setText (""+subj);
            else    tksRasp .setText (""+subj);
    }
  } // class SlucajniT.Prikazi
  
  // Ploca za rukovanje jednim statistickim pokazateljem.
  private class PloStatist extends Panel {

    Statistika stat;
    TextField tekst;
    Button dgmRadi, dgmBrisi;
    
    PloStatist (String nasl, Statistika stat, TextComponent tekst) {
      this.stat = stat;
      setLayout (new FlowLayout());
      if (nasl != null) add (new Label(nasl));
      add (tekst);
      add (dgmRadi = new Button ("Stani"));
      add (dgmBrisi = new Button ("Brisi"));
      dgmRadi.addActionListener (new RadiAkcija());
      dgmRadi.setBackground (new Color(255, 128,128));
      dgmBrisi.addActionListener (new BrisiAkcija());
    }
    
    // Posmatrac dugmeta 'radi'.
    private class RadiAkcija implements ActionListener {
      public void actionPerformed (ActionEvent d) {
        if (dgmRadi.getLabel().equals("Kreni")) {
          generator.dodaj (stat);
          dgmRadi.setLabel ("Stani");
          dgmRadi.setBackground (new Color(255, 128,128));
        } else {
          generator.brisi (stat);
          dgmRadi.setLabel ("Kreni");
          dgmRadi.setBackground (new Color(128, 255,128));
        }
      }
    } // class SlucajniT.PloStatist.RadiAkcija
    
    // Posmatrac dugmeta 'brisi'.
    private class BrisiAkcija implements ActionListener {
      public void actionPerformed (ActionEvent d) {
        stat.ispocetka ();
      }
    } // class SlucajniT.PloStatist.BrisiAkcija
  
  } // class SlucajniT.PloStatist
  
  // Ploca za rukovanje generatorom dogadjaja.
  private class PloGenerator extends Panel {
    
    Button dgmKreni = new Button ("Kreni");
    Button dgmStani = new Button ("Stani");
    Label oznSr  = new Label ("        Min"),
          oznDev = new Label ("        Max");
    TextField tksSr  = new TextField ("1", 6),
              tksDev = new TextField ("10", 6);
    
    PloGenerator () {
      add (new Label ("Generator"));
      DugmeAkcija da = new DugmeAkcija();
      dgmKreni.addActionListener (da);
      dgmStani.addActionListener (da);
      TekstPromena tp = new TekstPromena ();
      tksSr .addTextListener (tp);
      tksDev.addTextListener (tp);
      add (dgmKreni); add (dgmStani);
      add (oznSr);    add (tksSr);
      add (oznDev);   add (tksDev);
    }
    
    // Posmatrac dugmadi na ploci.
    private class DugmeAkcija implements ActionListener {
      public void actionPerformed (ActionEvent d) {
        Button dugme = (Button)d.getSource();
        if (dugme == dgmKreni) {
          if (novaRasp) {
            for (int i=0; i<stat.length; stat[i++].ispocetka());
            double sr  = Double.parseDouble(ploGen.tksSr .getText()),
                   dev = Double.parseDouble(ploGen.tksDev.getText());
            String oz = grupa.getSelectedCheckbox().getLabel();
            if (oz.equals(oznRasp[0])) {
              generator.raspodela (new Uniformni (sr, dev));
              ((Raspodela)stat[5]).opseg (sr, dev);
            } else if (oz.equals(oznRasp[1])) {
              generator.raspodela (new Ekspon(sr,
                                   new Uniformni ()));
              ((Raspodela)stat[5]).opseg (0, dev);
            } else if (oz.equals(oznRasp[2])) {
              generator.raspodela (new Gauss(sr,dev,
                                   new Uniformni ()));
              ((Raspodela)stat[5]).opseg (sr-5*dev, sr+5*dev);
            }
            novaRasp = false;
          }
          generator.kreni();
        } else if (dugme == dgmStani) {
          generator.stani();
        }
      }
    } // class SlucajniT.PloGenerator.DugmeAkcija
    
    private class TekstPromena implements TextListener {
      public void textValueChanged (TextEvent d) {
        novaRasp = true;
      }
    } // class SlucajniT.PloGenerator.TekstPromena
  
  } // class SlucajniT.PloGenerator
  
  // Ploca za izbor raspodele pseudoslucajnih brojeva.
  private class PloRaspodela extends Panel {
        
    PloRaspodela () {
      add (new Label ("Raspodela"));
      RaspPromena promena = new RaspPromena ();
      grupa = new CheckboxGroup ();
      for (int i=0; i<oznRasp.length; i++) {
        Checkbox radio = new Checkbox (oznRasp[i]);
        radio.setCheckboxGroup (grupa);
        add (radio);
        radio.addItemListener (promena);
        if (i==0) radio.setState (true);
      }
    }
    
    // Posmatrac promene stanja radio grupe.
    private class RaspPromena implements ItemListener {
      public void itemStateChanged (ItemEvent d) {
        novaRasp = true;
        if (((Checkbox)d.getSource()).getLabel().equals(oznRasp[0])) {
          ploGen.oznSr .setText ("        Min");
          ploGen.oznDev.setText ("        Max");
        } else {
          ploGen.oznSr .setText ("        Sr");
          ploGen.oznDev.setText ("        Dev");
        }
      }
    } // class SlucajniT.PloRaspodela.RaspPromena
  
  } // class SlucajniT.PloRaspodela
  
} // class SlucajniT