// Crtez.java - Crtez je slozena Figura koja moze da sadrzi 
//              proizvoljan broj figura.

package figure;

public class Crtez extends Figura {
   private double sir;
   private double vis;
   private int brojFigura;
   private Tacka doleLevo;
   private Figura[] figure = new Figura[5];

   public Crtez(Boja boja, Tacka doleLevo,
     double sir, double vis) {
     super (boja);
     this.doleLevo = doleLevo;
     this.sir = sir; this.vis = vis;
   }
   
   public Tacka doleLevo() { return doleLevo; }
   
   public Tacka goreDesno() { 
     return new Tacka (doleLevo.x()+sir, doleLevo.y()+vis);
   }
   
   public double sir() { return sir; }
   
   public double vis() { return vis; }
   
   public Figura kopija() {
     Figura nova = new Crtez (boja.kopija(), doleLevo.kopija(), sir, vis);
     Iterator iter = new CrtezIterator (this);
     for (iter.naPrvi(); !iter.gotovo(); iter.sledeci())
       try { nova.dodaj(iter.tekuci().kopija()); }
         catch (GNemaTekuceg g) {}
         catch (GNijeCrtez g) {}
     return nova;
   }
   
   public boolean pripada(Tacka T) {
     return T.x()>=doleLevo.x() && T.x()<=doleLevo.x()+sir &&
            T.y()>=doleLevo.y() && T.y()<=doleLevo.y()+vis    ;
   }
   
   public double P() { return sir * vis; }
   
   public Boja boja(Tacka T) throws GTackaNePripada {
     if (! pripada(T)) throw new GTackaNePripada();
     NadjiBoju nadji = new NadjiBoju (this, T);
     nadji.radi();
     if (nadji.rezultat() != null) return nadji.rezultat();
       else return boja;
   }
   
   public void dodaj(Figura fig) {
     if (brojFigura == figure.length) {
       Figura[] nove = new Figura [figure.length+5];
       for (int i=0; i<figure.length; i++)
         nove[i] = figure[i];
       figure = nove;
     }
     figure[brojFigura++] = fig;
   }
   
   public Figura dohvati(int ind) throws GIndeks {
     if (ind<0 || ind>=brojFigura) throw new GIndeks();
     return figure[ind];
   }
   
   public void brisi(int ind) throws GIndeks {
     if (ind<0 || ind>=brojFigura) throw new GIndeks();
     for (int i=ind; i<brojFigura-1; i++)
       figure[i] = figure[i+1];
     figure[--brojFigura] = null;
     if (figure.length-brojFigura>5) {
       Figura[] nove = new Figura [figure.length-5];
       for (int i=0; i<brojFigura; i++)
         nove[i] = figure[i];
       figure = nove;
     }
   }
   
   public int brojFigura() { return brojFigura; }
   
   public Iterator iterator() { return new CrtezIterator (this); }

} // class Crtez