// Raspodela.java - Pracenje raspodele generisanih
//                  pseudoslucajnih brojeva.

package slucajni;

public class Raspodela extends Statistika {
 
  private int vrs, kol;
  private double min, max;
  private int[] rasp;
   
  public Raspodela(double min, double max, int vrs, int kol) { 
    this.min = min; this.max = max;
    this.vrs = vrs; this.kol = kol;
    rasp = new int [vrs];
  }
  
  public void opseg (double min, double max) {
    this.min = min; this.max = max;
  }
   
  public void azuriraj(Subjekat subj) {
    double x = ((Generator)subj).vrednost();
    if (x>=min && x<max) {
      int k = (int)((x-min)/(max-min)*vrs);
      rasp[k]++;
      obavesti ();
    }
  }
   
  public void ispocetka() {
    for (int i=0; i<vrs; rasp[i++]=0);
    obavesti ();
  }
  
  public String toString () {
    StringBuffer s = new StringBuffer();
    int max=0;
    for (int i=0; i<rasp.length; i++)
      if (rasp[i] > max) max = rasp[i];
    if (max > 0) {
      double a = (double)kol / max;
      for (int i=0; i<rasp.length; i++) {
        int m = (int) (rasp[i] * a + 0.5);
        for (int j=0; j<m; j++) s.append('I');
        s.append('\n');
      }
    }
    return s.toString ();
  }

} // class Raspodela
