// Subjekat.java - Abstraktni subjekat za posmatranje.

package slucajni;

public abstract class Subjekat {
  
  private Elem prvi, posl;
   
  public synchronized void dodaj(Posmatrac posm) {
    Elem novi = new Elem (posm);
    if (prvi == null) prvi = novi;
      else            posl.sled = novi;
    posl = novi;
  }
   
  public synchronized void brisi(Posmatrac posm) {
    Elem tek = prvi, preth = null;
    while (tek!=null && tek.posm!=posm)
      { preth = tek; tek = tek.sled; }
    if (tek != null) {
      if (preth != null) preth.sled = tek.sled;
        else prvi = tek.sled;
      if (tek == posl) posl = preth;
    }
  }
   
  protected synchronized void obavesti() {
    for (Elem tek=prvi; tek!=null; tek=tek.sled)
      tek.posm.azuriraj (this);
  }
   
  public class Elem {

    private Posmatrac posm;
    private Elem sled;
      
    private Elem(Posmatrac posm) { this.posm = posm; }
    
  } // class Elem

} // class Subjekat
